
#include "coeffs.h"

#define N 64


void fir_sw(float *input, float *res)
{
	static float smpl[N];

	float accu;
	int i;

	for_shift:for (i=N-1; i>=0; i--)
	{
		smpl[i] = (i==0) ? *input : smpl[i-1];
	}


	accu = 0;
	for_mac: for (i=(N-1); i>=0; i--)
		accu = accu + (coeff_sw[i] * smpl[i]);

	*res = accu;
}
