#include "ap_int.h"
#include "ap_fixed.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "types.h"

extern void fir_sw(float *input, float *res);
extern void fir_hw(din_t *input, dout_t *res);


int main()
{
	float input_sw = 0.0f;
	float res_sw, res_hw_f;
	din_t input_hw;
	dout_t res_hw;
	float diff;

	srand (time(NULL));

	for (int i=0; i<100; i++)
	{
		//input_sw = (i==10) ? -1.0f : 0.0f;
		input_sw = (float)(rand()) / (float)(RAND_MAX+1);
		
		input_hw = input_sw;
		
		fir_sw(&input_sw, &res_sw);
		fir_hw(&input_hw, &res_hw);
		
		res_hw_f = res_hw;
		diff = res_sw - res_hw_f;
		printf("S: %03d \t Float: %1.6f \t Fixed: %1.6f \t Diff.: %1.8f\r\n", i, res_sw, res_hw_f, diff);
	}

	return 0;
}
